#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <time.h>

#include "kblib.h"

void plotasm(int x, int y, unsigned char col);
void setmode(int mode);
void setVGApalette(unsigned char *buffer);
void putsprite(int x,int y,int ang,int sn);
void cls(int color);
int point(int x, int y);
void pset(int x, int y, int color);
void GSget(int x, int y);
void GSput(int x, int y);

union REGS regs;
struct SREGS inreg;

struct {
  int type, angb, fundo[40][40], ontrack;
  float velo, px, py, pxb, pyb, ang;
} car;

unsigned char Pal_Array[256][3];
int active_bank,bank,maxx,maxy,minx,miny;
char data[1080];
float r[30][40], a[30][40];
int main(void)
{
   FILE *f=fopen("cars.gsg", "rb");
   FILE *f2=fopen("game.pal", "rb");
   FILE *f3=fopen("bana1.lev", "rb");
   float t,ttx,tty;
   int dl,i,j,y,x,xxx,yyy,xa,ya;
   unsigned char inf;

   fread(data, 1080, 1, f);

   /*for(i=0;i<256;i++)
     for(j=0;j<3;j++)
       Pal_Array[i][j]=fgetc(f2);*/

   kblib_init();
   setmode(0x13);

   for (y=-4;y<5;y++)
     for (x=-7;x<8;x++) {
       r[x+8][y+5] = sqrt((x*x)+(y*y));
       if (x<0) r[x+8][y+5] = -r[x+8][y+5];
       ttx=x; tty=y;
       if (ttx==0) t=0; else t=(tty/ttx);
       if (x==0) a[x+8][y+5]=(3.1415/4); else a[x+8][y+5]=atan(t);
     }
   car.px=160; car.pxb=159;
   car.py=186; car.pyb=185;
   car.ang=0;
   car.velo=0;
   car.type=5;

   for (yyy=0;yyy<200;yyy++)
     for (xxx=0;xxx<320;xxx++) {
       inf=fgetc(f3);
       plotasm(xxx,yyy,inf);
     }

   for(i=0;i<256;i++)
     for(j=0;j<3;j++)
       Pal_Array[i][j]=fgetc(f3);

   setVGApalette(&Pal_Array[0][0]);


   GSget(car.pxb-18,car.pyb-18);
   putsprite(car.pxb,car.pyb,car.ang,car.type);

   while(!kblib_map[KBLIB_ESC]){

	if (car.velo>.0001) sound(car.velo*100+(car.type*5)); else nosound();
	if (kblib_map[KBLIB_UP]) {
	  if(car.velo<.5)
	    car.velo+=.002;
	  else
	    car.velo*=1.01;
	} else {
	  if (car.velo>0) car.velo*=.995;
	  if (car.velo<.1) car.velo=0;
	}
	if (car.velo>10) car.velo=10;
	if (kblib_map[KBLIB_DOWN]) car.velo*=.97;
	if (kblib_map[KBLIB_RIGHT]) car.ang=fmod(car.ang + .5, 360);
	if (kblib_map[KBLIB_LEFT]) car.ang=fmod(car.ang - .5, 360);
	if (kblib_map[KBLIB_ENTER]) { car.type++; if(car.type==8) car.type=0; }

	if (kblib_map[KBLIB_1]) car.type=0;
	if (kblib_map[KBLIB_2]) car.type=1;
	if (kblib_map[KBLIB_3]) car.type=2;
	if (kblib_map[KBLIB_4]) car.type=3;
	if (kblib_map[KBLIB_5]) car.type=4;
	if (kblib_map[KBLIB_6]) car.type=5;
	if (kblib_map[KBLIB_7]) car.type=6;
	if (kblib_map[KBLIB_8]) car.type=7;

	if (car.ontrack!=1) car.velo*=.96;

	if (car.velo>0) {
	  car.px=fmod(car.px+car.velo*cos(car.ang*.0175), 320);
	  car.py=fmod(car.py+car.velo*sin(car.ang*.0175), 200);
	  if (car.px<5) car.px=5;
	  if (car.px>315) car.px=315;
	  if (car.py<5) car.py=5;
	  if (car.py>195) car.py=195;
	}

	if ((car.pxb!=car.px)||(car.pyb!=car.py)||(car.angb!=car.ang)) {
	  putsprite(car.px,car.py,car.ang,car.type);
	  car.pxb=car.px; car.pyb=car.py; car.angb=car.ang;
	}
   }

   kblib_kill();
   setmode(0x3);
   return 0;
}

void putsprite(int x,int y,int ang,int sn)
{
  float newang1=ang*.0175,newang2,newx,newy;
  int xx, yy, ofs;

  minx=32000; miny=32000; maxx=-32000; maxy=-32000;

  GSput(car.pxb-18,car.pyb-18);
  if ((point(car.px,car.py)>189)&&(point(car.px,car.py)<201)) car.ontrack=1; else car.ontrack=0;
  GSget(car.px-18,car.py-18);

  for (yy=1;yy<10;yy++)
    for (xx=1;xx<16;xx++) {
      newang2=newang1+a[xx][yy];
      newx=(cos(newang2)*r[xx][yy])+x;
      newy=(sin(newang2)*r[xx][yy])+y;
      ofs=((yy-1)*15+xx)+(sn*135);
      if((newx>maxx)&&(data[ofs]!=0)) maxx=newx;
      if((newx<minx)&&(data[ofs]!=0)) minx=newx;
      if((newy>maxy)&&(data[ofs]!=0)) maxy=newy;
      if((newy<miny)&&(data[ofs]!=0)) miny=newy;
      plotasm(newx,newy,data[ofs]);
    }
    for (x=minx;x<maxx+1;x++)
      for (y=miny;y<maxy+1;y++) {
	if((point(x,y)==0)&&(point(x-1,y)!=0)&&(point(x+1,y)!=0)) plotasm(x,y,point(x-1,y));
      }
}

void setVGApalette(unsigned char *buffer)
{
  regs.x.ax=0x1012;
  segread(&inreg);
  inreg.es=inreg.ds;
  regs.x.bx=0;
  regs.x.cx=256;
  regs.x.dx=(int)&buffer[0];
  int86x(0x10,&regs,&regs,&inreg);
}

void setmode(int mode)
{
  if(mode > 0x32)
  {
    active_bank=0;
    regs.x.ax=0x6F05;
    regs.h.bl=mode;
    int86(0x10,&regs,&regs);
    outpw(0x3C4,0xEA06);
  }
  else
  {
    regs.h.ah=0;
    regs.h.al=mode;
    int86(0x10,&regs,&regs);
  }
}

void plotasm(int x, int y, unsigned char col)
{
  if((x>=0)&&(x<320)&&(y>=0)&&(y<200)) {
    asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	xor al, al;
	mov ah, [col];
	mov es:[di], ah;

	pop es;
	pop ds;
    }
  }
}

void cls(int color)
{
  union REGS regs;
  regs.x.ax = 0x600;
  regs.x.cx = 0;
  regs.x.dx = 0x184F;
  regs.h.bh = color;
  int86(0x10,&regs,&regs);
}

int point(int x, int y)
{

  unsigned char col;

  asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	shl bx, 1;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	mov ax, es:[di];
	mov [col], al;

	pop es;
	pop ds;
  }
  return(col);
}

void pset(int x, int y, int color)
{
  long int offset;
  char far *address;
  int temp, temp2;

  offset=(long)320*(long)y+(long)x;
  bank=offset/65536L;
  offset=offset%65536L;
  if(bank!=active_bank)
  {
    active_bank=bank;
    regs.h.ah=bank & 0x01;
    regs.h.al=0xF9;
    outpw(0x3C4,regs.x.ax);
    temp=inpw(0x3CC);
    temp=temp & 0xDF;
    if((bank & 0x02) != 0)
      temp=temp | 0x20;
    outpw(0x3C2,temp);
    outp(0x3C4,0xF6);
    temp=inpw(0x3C5);
    temp=temp & 0xF0;
    temp2=((bank & 0x0C) >> 2) | (bank & 0x0C);
    temp=temp | temp2;
  }
  address=(char far *)(0xA0000000L + offset);
  *address=color;
}

void GSget(int x, int y)
{
  int xx,yy,gx=0,gy=0;
  for (yy=y;yy<y+31;yy++) {
    gx=0;
    for (xx=x;xx<x+31;xx++) {
      car.fundo[gx][gy] = point(xx,yy);
      gx++;
    }
    gy++;
  }
}

void GSput(int x, int y)
{
  int xx,yy,gx=0,gy=0;
  for (yy=y;yy<y+31;yy++) {
    gx=0;
    for (xx=x;xx<x+31;xx++) {
      plotasm(xx,yy,car.fundo[gx][gy]);
      gx++;
    }
    gy++;
  }
}